package com.gic.haoban.manage.api.service;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.manage.api.dto.PreDealLogInfoDTO;
import com.gic.haoban.manage.api.dto.SyncCheckDTO;
import com.gic.haoban.manage.api.dto.SyncSingleDealDTO;
import com.gic.haoban.manage.api.dto.SyncTaskDTO;

import java.util.List;

/**
 * Created 2020/4/9.
 *
 * @author hua
 */
public interface DealSyncOperationApiService {

    /**
     * 部门同步处理
     *
     * @param params
     */
    public void departmentDealMq(String params);

    /**
     * 处理前端数据
     *
     * @param addList
     * @param editList
     */
    public void dealDepartment(String taskId, String wxEnterpriseId, List<SyncSingleDealDTO> addList, List<SyncSingleDealDTO> editList);

    /**
     * 重新执行任务
     *
     * @param taskId
     */
    public void reDealDepartment(String taskId, int dataType);

    /**
     * 创建任务
     *
     * @param taskName
     * @param userId
     * @param desc
     */
    public String createTask(String wxEnterpriseId, String taskName, String userId, String desc);

    /**
     * 创建任务
     *
     * @param taskName
     * @param userId
     * @param desc
     */
    public String createQywxTask(String wxEnterpriseId, String taskName, String userId, String desc);

    /**
     * 关闭任务
     *
     * @param wxEnterpriseId
     * @return
     */
    public boolean closeTask(String wxEnterpriseId);


    /**
     * 解锁
     *
     * @param taskId
     */
    public void unlockTask(String taskId);

    /**
     * 校验是否锁
     *
     * @param wxEnterpriseId
     * @return
     */
    public String getTaskLock(String wxEnterpriseId);

    /**
     * 校验同步状态
     *
     * @param wxEnterpriseId
     * @return
     */
    public SyncCheckDTO getTaskCheck(String wxEnterpriseId);

    /**
     * 同步日志
     *
     * @param wxEnterpriseId
     * @return
     */
    public Page<SyncTaskDTO> listSyncTask(String wxEnterpriseId, BasePageInfo pageInfo);

    /**
     * 同步日志
     *
     * @param wxEnterpriseId
     * @return
     */
    public Page<PreDealLogInfoDTO> listSyncTaskDetail(String wxEnterpriseId, String taskId, BasePageInfo pageInfo);


    /**
     * 处理同步
     */
    public void dealQywxDepartment(String taskId, String wxEnterpriseId);

    /**
     * 清理不存在的数据
     * @param wxEnterpriseId
     * @param taskId
     */
    public void  cleanDiffrence(String wxEnterpriseId,String taskId);


}
