package com.gic.haoban.manage.service.service.impl;

import java.util.Date;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.manage.api.dto.MemberUnionidRelatedDTO;
import com.gic.haoban.manage.service.dao.mapper.MemberUnionidRelatedMapper;
import com.gic.haoban.manage.service.entity.MemberUnionidRelated;
import com.gic.haoban.manage.service.service.MemberUnionRelatedService;
import com.github.pagehelper.Page;

@Service
public class MemberUnionRelatedServiceImpl implements MemberUnionRelatedService {

	@Autowired
	private MemberUnionidRelatedMapper mapper;
	
	@Override
	public MemberUnionidRelatedDTO getByUnionId(String wxUserId, String unionid) {
		return EntityUtil.changeEntityByJSON(MemberUnionidRelatedDTO.class,mapper.getByUnionId(wxUserId,unionid));
	}
	@Override
	public MemberUnionidRelatedDTO getByMemberId(String wxUserId, String memberId) {
		return EntityUtil.changeEntityByJSON(MemberUnionidRelatedDTO.class,mapper.getByMemberId(wxUserId,memberId));
	}
	@Override
	public String addMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		dto.setStatusFlag(1);
		dto.setCreateTime(new Date());
		dto.setUpdateTime(new Date());
		dto.setMemberUnionidRelatedId(StringUtil.randomUUID());
		mapper.insert(EntityUtil.changeEntityByJSON(MemberUnionidRelated.class, dto));
		return dto.getMemberUnionidRelatedId();
	}

	@Override
	public void delMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		mapper.deleteByUnionidAndUserId(dto.getExternalUserid(),dto.getWxUserId());
	}

	@Override
	public List<MemberUnionidRelatedDTO> getByWxUserIdAndWxEnterpriseId(String wxUserId, String wxEnterpriseId) {
		return EntityUtil.changeEntityListByJSON(MemberUnionidRelatedDTO.class, mapper.getByWxUserIdAndWxEnterpriseId(wxUserId,wxEnterpriseId));
	}

	@Override
	public MemberUnionidRelatedDTO getByParams(String wxUserId, String enterpriseId, String name, String createTime) {
		return EntityUtil.changeEntityByJSON(MemberUnionidRelatedDTO.class,mapper.getByParams(wxUserId,enterpriseId,name,createTime));
	}

	@Override
	public void update(MemberUnionidRelatedDTO exsitDTO) {
		mapper.updateByPrimaryKeySelective(EntityUtil.changeEntityByJSON(MemberUnionidRelated.class, exsitDTO));
		
	}

	@Override
	public void clean(String cid) {
		mapper.cleanByCid(cid);
	}

	@Override
	public Page<MemberUnionidRelated> pageMemberUnionByParams(List<String> userIdList, List<String> sendMemberIds,
			String enterpriseId) {
		return mapper.pageMemberUnionByParams(userIdList,sendMemberIds,enterpriseId);
	}
}
