package com.gic.haoban.manage.web.controller;

import com.gic.haoban.common.utils.EntityUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.api.service.TestApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.qo.QywxXcxSendMessageQo;
import com.gic.wechat.api.dto.qywx.QywxXcxSendMessageDTO;
import com.gic.wechat.api.service.qywx.QywxSuiteApiService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * Created 2020/4/9.
 *
 * @author hua
 */
@RestController
@RequestMapping("/test")
public class TestController extends WebBaseController {


    private static final Logger logger= LoggerFactory.getLogger(TestController.class);

    @Autowired
    private QywxSuiteApiService qywxSuiteApiService;

    @Autowired
    private MemberUnionidRelatedApiService memberUnionidRelatedApiService;

    private final ExecutorService pools = Executors.newFixedThreadPool(500);

    @Autowired
    private TestApiService testApiService;

    @RequestMapping("/send-message-test")
    public HaobanResponse testSendMessage(QywxXcxSendMessageQo qo) {
        QywxXcxSendMessageDTO messageDTO = EntityUtil.changeEntityByOrika(QywxXcxSendMessageDTO.class, qo);
        ArrayList<String> list = new ArrayList<>();
        list.add(qo.getUserId());

        messageDTO.setUserIds(list);
        boolean b = qywxSuiteApiService.sendMessage("ww9ede832a84b7ae5f",
                "ww2c34dc56739bb105", messageDTO);
        if (b) {
            return resultResponse(HaoBanErrCode.ERR_1);
        } else {
            return resultResponse(HaoBanErrCode.ERR_0);
        }
    }

    @RequestMapping("/clean-out")
    public HaobanResponse cleanMessage(String cid) {
        memberUnionidRelatedApiService.cleanByCid(cid);
        return resultResponse(HaoBanErrCode.ERR_1);
    }

    @RequestMapping("/test-dubbo")
    public HaobanResponse dubbo(@RequestParam(defaultValue = "2000") Integer n,@RequestParam(defaultValue = "100") String t) {
        int i=n;
        while (i-->0) {
            int finalI = i;
            pools.execute(new Runnable(){
                @Override
                public void run() {
                    long start = System.currentTimeMillis();
                    testApiService.checkThread(finalI +"",Long.valueOf(t));
                    logger.info("时间:{}",System.currentTimeMillis()-start);
                }
            });
        }
        return resultResponse(HaoBanErrCode.ERR_1);
    }
}
