package com.gic.haoban.manage.web.init;

import com.gic.quartz.api.dto.QuartzTaskDTO;
import com.gic.quartz.api.service.QuartzService;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

@Component
public class MyApplicationContextAware implements ApplicationContextAware {
    private Logger log = LogManager.getLogger(MyApplicationContextAware.class);

    private static ApplicationContext applicationContext;
    
    @Autowired
	private QuartzService quartzService; 

	@Override
	public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
		log.info("【定时开始】----------------------");
		QuartzTaskDTO taskDTO = buildQuartzMessageDTO("haoban-message-status-time");
		taskDTO.setTaskParam("");
		taskDTO.setTaskStatus(1);
		taskDTO.setTaskTimeInfo("0 30 1 * * *");
//		taskDTO.setTaskTimeInfo("0 0/5 * * * *");
		quartzService.addOrUpdateQuartzTask(taskDTO);
		
	}
	
	private QuartzTaskDTO buildQuartzMessageDTO(String id) {
  	  QuartzTaskDTO taskDTO = new QuartzTaskDTO();
        taskDTO.setReferId(id);
        taskDTO.setTaskMethod("quartzUpdateMessageStatus");
        taskDTO.setTaskService("com.gic.haoban.app.customer.service.api.service.MessageLogApiService");
        return taskDTO;
	}

    
}
